<template>
  <div class="addLawList-box">
    <basic-container>
      <div class="law-reason-box">
        <el-row :gutter="20">
          <el-col :span="18">
            <el-input
                type="textarea"
                :rows="5"
                placeholder="请输入内容"
                v-model="addLawForm.projectName">
            </el-input>
          </el-col>
          <el-col :span="6">
            <div>
              <el-select v-model="addLawForm.type" placeholder="请选择执法类别" size="medium" style="width: 60%">
                <el-option label="行政处罚" value="0"></el-option>
                <el-option label="行政强制" value="1"></el-option>
              </el-select>
            </div>
            <div style="margin-top: 20px">
              <el-select v-model="addLawForm.beforeDeptDictDataName" placeholder="请选择所属领域" size="medium"
                         style="width: 60%">
                <el-option
                    v-for="item in lawThemeOptions"
                    :key="item.value"
                    :label="item.label"
                    :value="item.value">
                </el-option>
              </el-select>
            </div>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="18">
            <el-autocomplete
                class="mainKey"
                style="width: 100%"
                placeholder="请设置关键字"
                :fetch-suggestions="querySearch"
                v-model="addLawForm.keyword">
            </el-autocomplete>
          </el-col>
        </el-row>
      </div>
      <div class="addLawList-main">
        <div class="addLaw-inside">
          <div class="lawList-search">
            <el-row :gutter="20">
              <el-col :span="8">
                <!--<el-input placeholder="请输入内容" class="input-with-select">
                  <el-button slot="append" icon="el-icon-search"></el-button>
                </el-input>-->
                <el-autocomplete
                    style="width: 100%"
                    class="inline-input"
                    v-model="firstLawParam.lawName"
                    :fetch-suggestions="querySearchHandle"
                    placeholder="请输入内容"
                    :trigger-on-focus="false"
                    @select="handleSelect"
                ></el-autocomplete>
              </el-col>
              <el-col :span="4">
                <el-select @change="handleChange" v-model="firstLawParam.lawTiaoName" placeholder="请选择">
                  <el-option
                      v-for="item in lawListoptions"
                      :key="item.lawTiaoName"
                      :label="item.lawTiaoName"
                      :value="item.lawTiaoName">
                  </el-option>
                </el-select>
              </el-col>
            </el-row>
          </div>
          <div class="law-tiaokuan-content">
            <h1>{{ firstLawParam.lawTiaoContent }}</h1>
          </div>
        </div>
        <div id="mount-point"></div>
        <div class="addLawBtn">
          <img @click="addLawClick" src="../../../assets/lawImg/addIcon.png" alt="">
          <el-button @click="submitlawTiaoContent" class="submitBtn" size="medium" type="primary">保存事项清单</el-button>
        </div>

      </div>
    </basic-container>
  </div>
</template>

<script>
import {addLaw, getKeywords, getLaw, getLawTiao, lawInfo} from '@/api/lawList/lawList';
import {remote} from "@/api/admin/dict"
import Vue from 'vue'

export default {
  name: "addLawList",
  data() {
    return {
      lawTitlelist: [], // 模糊搜索法律条款回显
      lawTypeOptions: [],  //执法类别
      lawThemeOptions: [],  //执法主题
      lawListoptions: [], //法律条款选择
      keywordList: [],//已经设置过的关键字
      addLawForm: {
        id: '',
        projectName: '', //执法原因
        type: '',
        beforeDeptDictDataName: '',
        keyword: '',//关键字
      },

      firstLawParam: {//固定的第一条
        lawName: '',
        lawId: '',
        lawTiaoName: '',
        lawTiaoContent: '',
        lawDetailId: '',
        lawTiaoSeq: ''
      },
      nextLawDomArr: [],//动态追加的dom

    }
  },
  mounted() {
  },
  created() {
    this.init();
    this.getAllKeywords();
  },
  methods: {
    addLawClick() { //添加新的一条法律内容
      if (!this.nextLawDomArr[this.nextLawDomArr.length - 1]) {
        if (this.firstLawParam.lawTiaoContent == '') {
          this.$message.warning('先添加完当前条信息，再添加下一条')
          return false
        }
      } else {
        if (this.nextLawDomArr[this.nextLawDomArr.length - 1].nextLawParam.lawTiaoContent == '') {
          this.$message.warning('先添加完当前条信息，再添加下一条')
          return false
        }
      }


      let self = this;
      let periodDiv = Vue.extend({
        template: `
          <div class="addLaw-inside">
          <div class="lawList-search">
            <el-row :gutter="20">
              <el-col :span="8">
                <!--<el-input placeholder="请输入内容" class="input-with-select">
                  <el-button slot="append" icon="el-icon-search"></el-button>
                </el-input>-->
                <el-autocomplete
                    style="width: 100%"
                    class="inline-input"
                    v-model="nextLawParam.lawName"
                    :fetch-suggestions="querySearchHandle"
                    placeholder="请输入内容"
                    :trigger-on-focus="false"
                    @select="handleSelect"
                ></el-autocomplete>
              </el-col>
              <el-col :span="4">
                <el-select @change="handleChange" v-model="nextLawParam.lawTiaoName" placeholder="请选择">
                  <el-option
                      v-for="item in lawListoptions"
                      :key="item.lawTiaoName"
                      :label="item.lawTiaoName"
                      :value="item.lawTiaoName">
                  </el-option>
                </el-select>
              </el-col>
            </el-row>
          </div>
          <div class="law-tiaokuan-content">
            <h1>{{ nextLawParam.lawTiaoContent }}</h1>
          </div>
          <el-button style="font-size: 24px" type="text" @click="deleteLawBtn" icon="el-icon-error"
                     class="deleteLaw"></el-button>
          </div>
        `,
        data() {
          return {
            lawListoptions: [], //法律条款选择
            nextLawParam: {
              lawName: '',
              lawId: '',
              lawTiaoName: '',
              lawTiaoContent: '',
              lawDetailId: '',
              lawTiaoSeq: ''
            },//动态追加的
          }
        },
        methods: {
          deleteLawBtn() {
            for (let i = 0; i < self.nextLawDomArr.length; i++) {
              if (self.nextLawDomArr[i]._uid == this._uid) {
                self.nextLawDomArr.splice(i, 1)
              }
              $(this.$el).remove()
            }

          },
          querySearchHandle(queryString, cb) {  //模糊搜素
            getLaw(queryString).then(res => {
              this.lawTitlelist = []
              let resultList = res.data.data
              resultList.forEach(item => {
                this.lawTitlelist.push({
                  value: item.name,
                  id: item.id
                })
              })
              cb(this.lawTitlelist)
            })
          },
          handleSelect(item) {
            this.nextLawParam.lawName = item.value
            this.nextLawParam.lawId = item.id
            lawInfo(item.value).then(res => {
              this.lawListoptions = res.data.data
            })
          },
          handleChange(item) { //改变选中的条目
            getLawTiao(Object.assign({name: this.nextLawParam.lawName, tiaoName: item})).then(res => {
              this.nextLawParam.lawTiaoName = item
              this.nextLawParam.lawTiaoContent = res.data.data.tiaoContent
              this.nextLawParam.lawDetailId = res.data.data.id
              this.nextLawParam.lawTiaoSeq = res.data.data.sortSeq
            })
          }

        },
      })
      let component = new periodDiv().$mount();  // 每次添加需要重新new一个periodDiv
      let $dom = $(component.$el);  // 获取动态元素的jquery对象
      $("#mount-point").append($dom);  // 添加元素至相应位置
      this.nextLawDomArr.push(component)
    },
    init() {
      remote('before_dept').then(res => {  //选择所属领域
        this.lawThemeOptions = res.data.data
      })
    },

    submitlawTiaoContent() {
      if (!this.nextLawDomArr[this.nextLawDomArr.length - 1]) {
        if (this.firstLawParam.lawTiaoContent == '') {
          this.$message.warning('先添加完当前条信息再保存')
          return false
        }
      } else {
        if (this.nextLawDomArr[this.nextLawDomArr.length - 1].nextLawParam.lawTiaoContent == '') {
          this.$message.warning('先添加完当前条信息再保存')
          return false
        }
      }

      let allArr = []
      allArr.push(this.firstLawParam)
      this.nextLawDomArr.forEach(item => {
        allArr.push(item.nextLawParam);
      })

      addLaw(Object.assign(this.addLawForm, {lawDetailArr: JSON.stringify(allArr)})).then(res => {
        this.$message.success(res.data.msg)
        this.$store.commit('delVisitedViews', this.$route.path);
        this.$router.push('/lawList');
      })
    },
    querySearchHandle(queryString, cb) {  //模糊搜素
      getLaw(queryString).then(res => {
        this.lawTitlelist = []
        let resultList = res.data.data
        resultList.forEach(item => {
          this.lawTitlelist.push({
            value: item.name,
            id: item.id
          })
        })
        cb(this.lawTitlelist)
      })
    },
    handleSelect(item) {
      this.firstLawParam.lawName = item.value
      this.firstLawParam.lawId = item.id
      lawInfo(item.value).then(res => {
        this.lawListoptions = res.data.data
      })
    },
    handleChange(val) { //改变选中的条目
      getLawTiao(Object.assign({name: this.firstLawParam.lawName, tiaoName: val})).then(res => {
        this.firstLawParam.lawTiaoName = val
        this.firstLawParam.lawTiaoContent = res.data.data.tiaoContent
        this.firstLawParam.lawDetailId = res.data.data.id
        this.firstLawParam.lawTiaoSeq = res.data.data.sortSeq
      })

    },
    querySearch(queryString, cb) {
      var keywordList = this.keywordList;
      var results = queryString ? keywordList.filter(this.createFilter(queryString)) : keywordList;
      // 调用 callback 返回建议列表的数据
      cb(results);
    },
    createFilter(queryString) {
      return (keyword) => {
        return (keyword.value.toLowerCase().indexOf(queryString.toLowerCase()) === 0);
      };
    },
    getAllKeywords() {
      getKeywords().then(res => {
        this.keywordList = res.data.data;
      })
    }
  }
}
</script>

<style>
  h1,h2,h3,h4,h5{
    font-weight: normal;
    font-size: 12px;
  }
 .lawList-search{
   margin-top:10px;
 }
  .addLawList-main{
    border-radius: 4px;
    margin-top: 20px;
    padding-bottom: 30px;
  }
  .addLaw-inside{
    background-color: #eff3fb;
    padding:20px;
    box-sizing: border-box;
    margin-top: 20px;
    position: relative;
  }
  .law-tiaokuan-content{
    background-color: #fff;
    padding:40px 40px;
    box-sizing: border-box;
    border-radius: 4px;
    box-shadow: 0 0 10px rgba(172,198,221,0.45);
    margin-top: 20px;
    /*min-height: 150px;*/
  }
  .law-tiaokuan-content h1{
    line-height: 1.8;
    text-indent: 26px;
    font-size: 12px;
  }
  .deleteLaw{
    position: absolute;
    right: -10px;
    top: -10px;
    width: 24px;
    height: 24px;
  }
  .addLawBtn{
    display: flex;
    justify-content: center;
    margin-top: 20px;
    cursor: pointer;
    position: relative;
  }
  .submitBtn{
    position: absolute;
    right: 0px;
    bottom:0
  }
  .addLawBtn img{
    width: 50px;
    height: 50px;
  }
  .deleteLaw{
    cursor: pointer;
  }
</style>
<style lang="scss">
  .mainKey {
    .el-input__inner, .vue-treeselect__control, .el-textarea__inner {
      border: 1px solid #6a76fb;
      box-shadow: 0 0 10px rgba(66,78,208,0.5);
    }
  }
</style>
